/* roadmap_label.h - Manage map labels.
 *
 * LICENSE:
 *
 *   Copyright 2006 Ehud Shabtai
 *
 *   This code was mostly taken from UMN Mapserver
 *   
 *   This file is part of RoadMap.
 *
 *   RoadMap is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   RoadMap is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with RoadMap; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __ROADMAP_LABEL__H
#define __ROADMAP_LABEL__H

#include "roadmap.h"
#include "roadmap_gui.h"

/* should be related by a power of 2 */
#define MIN_LABELS 256
#define MAX_LABELS 2048

typedef struct {

  int featuresize;

  PluginLine line;
  PluginStreet street;

  RoadMapGuiPoint point; /* label point */
  RoadMapGuiRect bbox; /* label bounding box */
  RoadMapGuiPoint poly[4];

  short angle; /* degrees */
  short status; /* has this label been drawn or not */

} labelCacheMemberObj;

typedef struct {
  labelCacheMemberObj **labels;
  int numlabels;
  int maxlabels;
} labelCacheObj;


int roadmap_label_add (const RoadMapGuiPoint *point, int angle,
                       int featuresize, const PluginLine *line);

int roadmap_label_activate (void);
int roadmap_label_initialize (void);

int roadmap_label_draw_cache (int angles);

#endif // __ROADMAP_LABEL__H
